////////////////////////////////////////////////////////////
// Nicholas Lance gtg175y
// Brien Applegate
// Charlie Holder
////////////////////////////////////////////////////////////

#include "main.pal.c"
#include "1.map.c"
#include "1.raw.c"
#include "2.raw.c"
#include "2.map.c"
#include "3.map.c"
#include "3.raw.c"
#include "4.raw.c"
#include "4.map.c"
#include "top_middle.map.c"
#include "top_middle.raw.c"
#include "bottom_middle.map.c"
#include "bottom_middle.raw.c"
#include "up_mid_1.raw.c"
#include "up_mid_1.map.c"
#include "up_mid_2.raw.c"
#include "up_mid_2.map.c"
#include "up_mid_3.raw.c"
#include "up_mid_3.map.c"
#include "down_mid_1.raw.c"
#include "down_mid_2.raw.c"
#include "down_mid_2_open.raw.c"
#include "down_mid_2_open.map.c"
#include "down_mid_3.raw.c"
#include "down_mid_1.map.c"
#include "down_mid_2.map.c"
#include "down_mid_3.map.c"
#include "wolfforward.h"
#include "wolfforward.c"
#include "wolfbackwards.h"
#include "wolfbackwards.c"
#include "wolfsideways1.h"
#include "wolfsideways1.c"
#include "wolfsideways2.h"
#include "wolfsideways2.c"
#include "king_front.c"
#include "king_front.h"
#include "key0.h"
#include "key0.c"
#include "key1.h"
#include "key1.c"
#include "key2.h"
#include "key2.c"
#include "key3.h"
#include "key3.c"
#include "key4.h"
#include "key4.c"
#include "key5.h"
#include "key5.c"
#include "knight_back_left.c"
#include "knight_back_left.h"
#include "knight_back_right.c"
#include "knight_back_right.h"
#include "knight_front_left.c"
#include "knight_front_left.h"
#include "knight_front_right.c"
#include "knight_front_right.h"
#include "knight_left_left.c"
#include "knight_left_left.h"
#include "knight_left_right.c"
#include "knight_left_right.h"
#include "villager_left_left.c"
#include "villager_left_left.h"
#include "villager_left_right.c"
#include "villager_left_right.h"
#include "villager_back_left.c"
#include "villager_back_left.h"
#include "villager_front_left.c"
#include "villager_front_left.h"

//added by Brien

#include "castle1a.pal.c"

#include "castle1a.map.c"
#include "castle1b.map.c"
#include "castle1c.map.c"
#include "castle1d.map.c"
#include "castle1e.map.c"
#include "castle1f.map.c"
#include "castle1g.map.c"
#include "castle1h.map.c"
#include "castle1i.map.c"
#include "castle1j.map.c"
#include "castle1k.map.c"
#include "castle1l.map.c"
#include "castle1m.map.c"
#include "castle1n.map.c"
#include "castle1o.map.c"
#include "castle1p.map.c"

#include "castle1a.raw.c"
#include "castle1b.raw.c"
#include "castle1c.raw.c"
#include "castle1d.raw.c"
#include "castle1e.raw.c"
#include "castle1f.raw.c"
#include "castle1g.raw.c"
#include "castle1h.raw.c"
#include "castle1i.raw.c"
#include "castle1j.raw.c"
#include "castle1k.raw.c"
#include "castle1l.raw.c"
#include "castle1m.raw.c"
#include "castle1n.raw.c"
#include "castle1o.raw.c"
#include "castle1p.raw.c"

//function prototype
void DMAFastCopy(void*, void*, unsigned int, unsigned int);

//defines needed by DMAFastCopy
#define REG_DMA3SAD *(volatile unsigned int*)0x40000D4
#define REG_DMA3DAD *(volatile unsigned int*)0x40000D8
#define REG_DMA3CNT *(volatile unsigned int*)0x40000DC
#define DMA_ENABLE 0x80000000
#define DMA_TIMING_IMMEDIATE 0x00000000
#define DMA_16 0x00000000
#define DMA_32 0x04000000
#define DMA_32NOW (DMA_ENABLE | DMA_TIMING_IMMEDIATE | DMA_32)
#define DMA_16NOW (DMA_ENABLE | DMA_TIMING_IMMEDIATE | DMA_16)

//scrolling registers for background 0
#define REG_BG0HOFS *(volatile unsigned short*)0x4000010
#define REG_BG0VOFS *(volatile unsigned short*)0x4000012

//background setup registers and data
#define REG_BG0CNT *(volatile unsigned short*)0x4000008
#define REG_BG1CNT *(volatile unsigned short*)0x400000A
#define REG_BG2CNT *(volatile unsigned short*)0x400000C
#define REG_BG3CNT *(volatile unsigned short*)0x400000E
#define BG_COLOR256 0x80
#define CHAR_SHIFT 2
#define SCREEN_SHIFT 8
#define WRAPAROUND 0x1

//background tile bitmap sizes
#define TEXTBG_SIZE_256x256 0x0
#define TEXTBG_SIZE_256x512	0x8000
#define TEXTBG_SIZE_512x256	0x4000
#define TEXTBG_SIZE_512x512	0xC000

//background memory offset macros
#define CharBaseBlock(n) (((n)*0x4000)+0x6000000)
#define ScreenBaseBlock(n) (((n)*0x800)+0x6000000)

//background mode identifiers
#define BG0_ENABLE 0x100
#define BG1_ENABLE 0x200
#define BG2_ENABLE 0x400
#define BG3_ENABLE 0x800

//video identifiers
#define REG_DISPCNT *(unsigned int*)0x4000000
#define BGPaletteMem ((unsigned short*)0x5000000)
#define SetMode(mode) REG_DISPCNT = (mode)

//vertical refresh register
#define REG_DISPSTAT   *(volatile unsigned short*)0x4000004

//button identifiers
#define BUTTON_RIGHT 16
#define BUTTON_LEFT  32
#define BUTTON_UP    64
#define BUTTON_DOWN  128
#define BUTTONS (*(volatile unsigned int*)0x04000130)

//object attribute memory state address
#define SpriteMem ((unsigned short*)0x7000000)

//object attribute memory image address
#define SpriteData ((unsigned short*)0x6010000)

//object attribute memory palette address
#define SpritePal ((unsigned short*)0x5000200)

// tile 8x8@4bpp: 32bytes; 8 ints
typedef struct { unsigned int data[8];  } TILE, TILE4;
// tile block: 32x16 tiles
typedef TILE  CHARBLOCK[512];

#define tile_mem  ( (CHARBLOCK*)0x06000000)

//sprite constants
#define OBJ_MAP_2D 0x0
#define OBJ_MAP_1D 0x40
#define OBJ_ENABLE 0X1000

//sprite attrib0 constants
#define ROTATION_FLAG 0x100
#define SIZE_DOUBLE 0x200
#define MODE_NORMAL 0x0
#define MODE_TRANSPARENT 0x400
#define MODE_WINDOWED 0x800
#define MOSAIC 0x1000
#define COLOR_16 0x0000
#define COLOR_256 0x2000
#define SQUARE 0x0
#define TALL 0x4000
#define WIDE 0X8000

//sprite attrib1 constants
#define HORI_FLIP 0x1000
#define VERTI_FLIP 0x2000
#define SIZE_8 0x0
#define SIZE_16 0x4000
#define SIZE_32 0x8000
#define SIZE_64 0xC000

//sprite attrib2 constants
#define PRIORITY(n) ((n) << 10)
#define PALETTE(n) ((n) << 12)

//greatest coordinate movements
signed int Y_MAX = (160);//144
signed int Y_MIN = 0;//0
signed int X_MAX = (240);//224
signed int X_MIN = 0;//0

//Steps to move till flip
#define MOVE_STEP 40
#define MOVE_SPEED .4
#define VIL_MOVE .2
#define KNI_MOVE .1
#define KEY_WAIT 50

//Sprite Pic
#define VIL_FRONT 68
#define VIL_BACK 64
#define VIL_LEFT1 72
#define VIL_LEFT2 76
#define KNI_FRONT1 48
#define KNI_FRONT2 52
#define KNI_BACK1 40
#define KNI_BACK2 44
#define KNI_LEFT1 56
#define KNI_LEFT2 60

//sprite structs
typedef struct tagSprite
{
    unsigned short attrib0;
    unsigned short attrib1;
    unsigned short attrib2;
    unsigned short fill;
}Sprite, *pSprite;

typedef struct tagVillager
{
    float x, y;
    int screen, steps, index;
}Villager, *pVillager;

typedef struct tagKnight
{
    float x, y;
    int screen, steps, index;
}Knight, *pKnight;

typedef struct tagKey
{
    float x, y;
    unsigned int frame, anim, screen;
    signed int sign;
}Key, *pKey;

//array of 128 sprites
Sprite sprites[128];

//array of 50 Villagers
int villager_count;
Villager villagers[50];

//array of 50 Knights
int knight_count;
Knight knights[50];

void animateKey();
void determineButtonMovement();
void checkScreenChange();
void UpdateMap(unsigned int screen);
void collideMap(float * x, float* y, float y_inc, float x_inc);
void drawSprites();
void startGame();
void clearSprites();
void determineVillagerMovement(float* x_vil, float* y_vil, int index);
void determineKnightMovement(float* x_vil, float* y_vil, int index);
void volatile UpdateSpriteMemory()
{
    int n;
    unsigned short* temp;
    temp = (unsigned short*)sprites;
    for(n = 0; n < 128 * 4; n++)
    {
        SpriteMem[n] = temp[n];
    }
}
//wait for vertical refresh
void WaitVBlank(void)
{
    while((REG_DISPSTAT & 1));
}

int current_screen, current_map, eaten = 0, n, steps = 0, hasKey = 0, king_screen = 14, r;
float x = 150, y = 100;

Key key;

//Charlie's Variables and #defines
void checkSpriteCollision() {
    //key collision
    if(current_screen == key.screen) {
        if ((int)(key.x) + 16 < (int)x) { }
        else if ((int)(key.x) > (int)x + 16) { }
        else if ((int)(key.y) + 16 < (int)y) { }
        else if ((int)(key.y) > (int)y + 16) { }
        else // they are collided
        {
            key.screen = 0;
            hasKey = 1;
        }
    }

    if(current_screen == king_screen) {
        if ((int)(88) + 32 < (int)x) { }
        else if ((int)(88) + 8 > (int)x + 16) { }
        else if ((int)(45) + 32 < (int)y) { }
        else if ((int)(45) + 8> (int)y + 16) { }
        else // they are collided
        {
            king_screen = 0;
        }
    }

    //villager collision
    for(n = 0; n < 50; n++) {
        if(villagers[n].screen == current_screen) {
            if ((int)(villagers[n].x)+16 < (int)x) { }
            else if ((int)(villagers[n].x) > (int)x+16) { }
            else if ((int)(villagers[n].y)+16 < (int)y) { }
            else if ((int)(villagers[n].y) > (int)y+16) { }
            else // they are collided
            {
                villagers[n].screen = 0; eaten++;
            }
        }
    }
    
    //knight collision
    for(n = 0; n < 50; n++) {
        if(knights[n].screen == current_screen) {
            if ((int)(knights[n].x)+16 < (int)x) { }
            else if ((int)(knights[n].x) > (int)x+16) { }
            else if ((int)(knights[n].y)+16 < (int)y) { }
            else if ((int)(knights[n].y) > (int)y+16) { }
            else // they are collided
            {
                startGame();
            }
        }
    }
}
//Brien's Variables and #defines
void init();
int main(void)
{
    
    init();
    
    startGame();

    //main game loop
	while(1)
	{
        //wait for vertical refresh
		WaitVBlank();
		drawSprites();
		determineButtonMovement();
		for(n = 0; n < 50; n++)
        {
            if (villagers[n].screen == current_screen)
            {
                determineVillagerMovement(&(villagers[n].x), &(villagers[n].y), n);
            }
            if (knights[n].screen == current_screen)
            {
                determineKnightMovement(&(knights[n].x), &(knights[n].y), n);
            }
        }
		checkSpriteCollision();
		checkScreenChange();
		
	    if(eaten >= 20) {
            key.screen = 8;
            eaten = 0;
        }
        if(hasKey == 1) {
            UpdateMap(8);
            hasKey++;
        }
        if(hasKey >= 1 && (y >= 114) && (y <=120) && (x > 110) && (x < 130))
        {
            x = 110;
            y = 100;
            current_map = 1;
            UpdateMap(27);
        }
        //steps increase
        steps += 1;
        UpdateSpriteMemory();
		WaitVBlank();
		
	//	for(n = 0; n < 4000; n++);
	}
	return 0;
}

////////////////////////////////////////////////////////////
// Function: DMAFastCopy
// Fast memory copy function built into hardware
////////////////////////////////////////////////////////////
void DMAFastCopy(void* source, void* dest, unsigned int count,
    unsigned int mode)
{
    if (mode == DMA_16NOW || mode == DMA_32NOW)
    {
    	REG_DMA3SAD = (unsigned int)source;
        REG_DMA3DAD = (unsigned int)dest;
        REG_DMA3CNT = count | mode;
    }
}

void setBounds(int min_x, int min_y, int max_x, int max_y)
{
    Y_MIN = min_y;
    Y_MAX = max_y;
    X_MIN = min_x;
    X_MAX = max_x;
}
void UpdateMap(unsigned int screen)
{
    if (current_map == 0)
    {
        DMAFastCopy((void*)main_Palette, (void*)BGPaletteMem, 8, DMA_32NOW);
    }
    else if (current_map == 1)
    {
        DMAFastCopy((void*)castle_Palette, (void*)BGPaletteMem, 128, DMA_32NOW);
    }
    if(screen >= 1 && screen <= 31)
    {
        REG_BG0CNT = TEXTBG_SIZE_256x256 | (screen << SCREEN_SHIFT);
        current_screen = screen;
    }
    switch(screen)
    {
        case 1:
        {
            DMAFastCopy((void*)first_Tiles, (void*)CharBaseBlock(0), 576/2, DMA_32NOW);
            setBounds(40, 55, 230, 150);
            break;
        }
        case 2:
        {
            DMAFastCopy((void*)top_middle_Tiles, (void*)CharBaseBlock(0), 576/2, DMA_32NOW);
            setBounds(0, 55, 230, 150);
            break;
        }
        case 3:
        {
            DMAFastCopy((void*)second_Tiles, (void*)CharBaseBlock(0), 576/2, DMA_32NOW);
            setBounds(0, 55, 185, 150);
            break;
        }
        case 4:
        {
            DMAFastCopy((void*)up_mid_1_Tiles, (void*)CharBaseBlock(0), 576/2, DMA_32NOW);
            setBounds(40, 0, 230, 150);
            break;
        }
        case 5:
        {
            DMAFastCopy((void*)up_mid_2_Tiles, (void*)CharBaseBlock(0), 576/2, DMA_32NOW);
            setBounds(0, 0, 230, 9);
            break;
        }
        case 6:
        {
            DMAFastCopy((void*)up_mid_3_Tiles, (void*)CharBaseBlock(0), 576/2, DMA_32NOW);
            setBounds(0, 0, 185, 150);
            break;
        }
        case 7:
        {
            DMAFastCopy((void*)down_mid_1_Tiles, (void*)CharBaseBlock(0), 672/2, DMA_32NOW);
            setBounds(40, 0, 230, 150);
            break;
        }
        case 8:
        {
            if(hasKey >= 1){
                DMAFastCopy((void*)down_mid_2_open_Map, (void*)ScreenBaseBlock(8), 1024/2, DMA_32NOW);
                DMAFastCopy((void*)down_mid_2_open_Tiles, (void*)CharBaseBlock(0), 736/2, DMA_32NOW);
            }else
            {
                DMAFastCopy((void*)down_mid_2_Tiles, (void*)CharBaseBlock(0), 768/2, DMA_32NOW);
            }
            clearSprites();
            setBounds(0, 114, 230, 150);
            break;
        }
        case 9:
        {
            DMAFastCopy((void*)down_mid_3_Tiles, (void*)CharBaseBlock(0), 672/2, DMA_32NOW);
            setBounds(0, 0, 185, 150);
            break;
        }
        case 10:
        {
            DMAFastCopy((void*)third_Tiles, (void*)CharBaseBlock(0), 608/2, DMA_32NOW);
            setBounds(40, 0, 230, 80);
            break;
        }
        case 11:
        {
            DMAFastCopy((void*)bottom_middle_Tiles, (void*)CharBaseBlock(0), 576/2, DMA_32NOW);
            setBounds(0, 0, 230, 80);
            break;
        }
        case 12:
        {
            DMAFastCopy((void*)fourth_Tiles, (void*)CharBaseBlock(0), 608/2, DMA_32NOW);
            setBounds(0, 0, 185, 80);
            break;
        }
        
        // added by Brien
        case 13:
        {
            DMAFastCopy((void*)castle1a_Tiles, (void*)CharBaseBlock(0), 352/2, DMA_32NOW);
            setBounds(30, 25, 160, 160);
            break;
        }
        case 14:
        {
            DMAFastCopy((void*)castle1b_Tiles, (void*)CharBaseBlock(0), 368/2, DMA_32NOW);
            setBounds(30, 25, 190, 160);
            break;
        }
        case 15:
        {
            DMAFastCopy((void*)castle1c_Tiles, (void*)CharBaseBlock(0), 368/2, DMA_32NOW);
            setBounds(35, 30, 240, 110);
            break;
        }
        case 16:
        {
            DMAFastCopy((void*)castle1d_Tiles, (void*)CharBaseBlock(0), 352/2, DMA_32NOW);
            setBounds(0, 60, 85, 160);
            clearSprites();
            break;
        }
        case 17:
        {
            DMAFastCopy((void*)castle1e_Tiles, (void*)CharBaseBlock(0), 288/2, DMA_32NOW);
            setBounds(140, 0, 240, 160);
            clearSprites();
            break;
        }
        case 18:
        {
            DMAFastCopy((void*)castle1f_Tiles, (void*)CharBaseBlock(0), 352/2, DMA_32NOW);
            setBounds(0, 0, 195, 85);
            clearSprites();
            break;
        }
        case 19:
        {
            DMAFastCopy((void*)castle1g_Tiles, (void*)CharBaseBlock(0), 368/2, DMA_32NOW);
            setBounds(35, 30, 240, 110);
            break;
        }
        case 20:
        {
            DMAFastCopy((void*)castle1h_Tiles, (void*)CharBaseBlock(0), 288/2, DMA_32NOW);
            setBounds(0, 0, 85, 160);
            clearSprites();
            break;
        }
        case 21:
        {
            DMAFastCopy((void*)castle1i_Tiles, (void*)CharBaseBlock(0), 288/2, DMA_32NOW);
            setBounds(140, 0, 240, 160);
            clearSprites();
            break;
        }
        case 22:
        {
            DMAFastCopy((void*)castle1j_Tiles, (void*)CharBaseBlock(0), 128/2, DMA_32NOW);
            setBounds(0, 60, 240, 85);
            clearSprites();
            break;
        }
        case 23:
        {
            DMAFastCopy((void*)castle1k_Tiles, (void*)CharBaseBlock(0), 368/2, DMA_32NOW);
            setBounds(0, 30, 185, 110);
            break;
        }
        case 24:
        {
            DMAFastCopy((void*)castle1l_Tiles, (void*)CharBaseBlock(0), 128/2, DMA_32NOW);
            setBounds(65, 0, 85, 160);
            clearSprites();
            break;
        }
        case 25:
        {
            DMAFastCopy((void*)castle1m_Tiles, (void*)CharBaseBlock(0), 368/2, DMA_32NOW);
            setBounds(30, 0, 230, 110);
            break;
        }
        case 26:
        {
            DMAFastCopy((void*)castle1n_Tiles, (void*)CharBaseBlock(0), 128/2, DMA_32NOW);
            setBounds(0, 60, 240, 85);
            clearSprites();
            break;
        }
        case 27:
        {
            DMAFastCopy((void*)castle1o_Tiles, (void*)CharBaseBlock(0), 432/2, DMA_32NOW);
            setBounds(0, 30, 240, 110);
            break;
        }
        case 28:
        {
            DMAFastCopy((void*)castle1p_Tiles, (void*)CharBaseBlock(0), 368/2, DMA_32NOW);
            setBounds(0, 0, 85, 85);
            clearSprites();
            break;
        }
        default: break;
    }
}

void collideMap(float * x, float* y, float y_inc, float x_inc)
{
    if ((current_screen == 4) && (*y >= 0) && (*x > 155) && (*x < 210) && (*y <= 9))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 4) && (*y >= 9) && (*x > 155) && (*y < 128))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 4) && (*y >= 128) && (*x > 162))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 6) && (*y >= 0) && (*x > 10) && (*x < 70) && (*y <= 9))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 6) && (*y >= 9) && (*x < 70) && (*y < 128))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 6) && (*y >= 128) && (*x < 63))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 7) && (*y >= 0) && (*x > 155) && (*y < 112))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 7) && (*y <= 128) && *x > 155 && *x < 210)
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 9) && (*y >= 0) && (*x < 70) && (*y < 112))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 9) && (*y <= 128) && *x < 70 && *x > 12)
    {
        *y += y_inc;
        *x += x_inc;
    }

    // added by Brien
    if ((current_screen == 13) && (*x < 140) && (*y > 120))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 14) && (*x < 165) && (*y > 112))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 15) && (*x > 185) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 15) && (*x > 185) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 16) && (*x < 65) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 17) && (*x > 160) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 17) && (*x > 160) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 18) && (*x < 165) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 19) && (*x > 185) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 19) && (*x > 185) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 20) && (*x < 65) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 20) && (*x < 65) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 21) && (*x > 160) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 21) && (*x > 160) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }

    if ((current_screen == 23) && (*x < 35) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 23) && (*x < 35) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }

    if ((current_screen == 25) && (*x > 160) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 25) && (*x < 140) && (*y < 35))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 25) && (*x > 160) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 27) && (*x < 35) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 27) && (*x < 35) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 27) && (*x > 185) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
    else if ((current_screen == 27) && (*x > 185) && (*y > 85))
    {
        *y += y_inc;
        *x += x_inc;
    }
    if ((current_screen == 28) && (*x < 65) && (*y < 60))
    {
        *y += y_inc;
        *x += x_inc;
    }
}


void determineButtonMovement()
{
    if(!(BUTTONS & BUTTON_DOWN) && (y <= Y_MAX) && (x >= X_MIN) && !(BUTTONS & BUTTON_LEFT))
    {
        y += MOVE_SPEED;
        x -= MOVE_SPEED;
        collideMap(&x, &y, (MOVE_SPEED*-1), MOVE_SPEED);
        sprites[0].attrib0 = (sprites[0].attrib0 & 0xFF00) | (int)y;
        sprites[0].attrib1 = (sprites[0].attrib1 & 0xFE00) | (int)x;
        sprites[0].attrib2 = (sprites[0].attrib2 & 0xFC00) | 0;
        if (steps >= MOVE_STEP)
        {
        if((sprites[0].attrib1 & (HORI_FLIP)) == HORI_FLIP)
        {
            sprites[0].attrib1 = (sprites[0].attrib1 & (0xEFFF));
        }
        else
        {
            sprites[0].attrib1 |= HORI_FLIP;
        }
        steps = 0;
        }
    }
    else if(!(BUTTONS & BUTTON_DOWN) && (y <= Y_MAX) && (x <= X_MAX) && !(BUTTONS & BUTTON_RIGHT))
    {
        y += MOVE_SPEED;
        x += MOVE_SPEED;
        collideMap(&x, &y, (MOVE_SPEED*-1), (MOVE_SPEED*-1));
        sprites[0].attrib0 = (sprites[0].attrib0 & 0xFF00) | (int)y;
        sprites[0].attrib1 = (sprites[0].attrib1 & 0xFE00) | (int)x;
        sprites[0].attrib2 = (sprites[0].attrib2 & 0xFC00) | 0;
        if (steps >= MOVE_STEP)
        {
            if((sprites[0].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[0].attrib1 = (sprites[0].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[0].attrib1 |= HORI_FLIP;
            }
            steps = 0;
        }
    }
    else if(!(BUTTONS & BUTTON_UP) && (y >= Y_MIN) && (x >= X_MIN) && !(BUTTONS & BUTTON_LEFT))
    {
        y -= MOVE_SPEED;
        x -= MOVE_SPEED;
        collideMap(&x, &y, MOVE_SPEED, MOVE_SPEED);
        sprites[0].attrib0 = (sprites[0].attrib0 & 0xFF00) | (int)y;
        sprites[0].attrib1 = (sprites[0].attrib1 & 0xFE00) | (int)x;
        sprites[0].attrib2 = (sprites[0].attrib2 & 0xFC00) | 4;
        if (steps >= MOVE_STEP)
        {
            if((sprites[0].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[0].attrib1 = (sprites[0].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[0].attrib1 |= HORI_FLIP;
            }
            steps = 0;
        }
    }
    else if(!(BUTTONS & BUTTON_UP) && (y >= Y_MIN) && (x <= X_MAX) && !(BUTTONS & BUTTON_RIGHT))
    {
        y -= MOVE_SPEED;
        x += MOVE_SPEED;
        collideMap(&x, &y, MOVE_SPEED, (MOVE_SPEED*-1));
        sprites[0].attrib0 = (sprites[0].attrib0 & 0xFF00) | (int)y;
        sprites[0].attrib1 = (sprites[0].attrib1 & 0xFE00) | (int)x;
        sprites[0].attrib2 = (sprites[0].attrib2 & 0xFC00) | 4;
        if (steps >= MOVE_STEP)
        {
            if((sprites[0].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[0].attrib1 = (sprites[0].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[0].attrib1 |= HORI_FLIP;
            }
            steps = 0;
        }
    }
    else if(!(BUTTONS & BUTTON_LEFT) && (x >= X_MIN))
    {
        x -= MOVE_SPEED;
        collideMap(&x, &y, 0, MOVE_SPEED);
        sprites[0].attrib1 = (sprites[0].attrib1 & 0xFE00) | (int)x;
        sprites[0].attrib1 = (sprites[0].attrib1 | HORI_FLIP);
        if (steps >= MOVE_STEP)
        {
            if((sprites[0].attrib2 & 12) == 12)
            {
                sprites[0].attrib2 = ((sprites[0].attrib2 & 0xFC00) | 8);
            }
            else
            {
                sprites[0].attrib2 = ((sprites[0].attrib2 & 0xFC00) | 12);
            }
            steps = 0;
        }
    }
    else if(!(BUTTONS & BUTTON_RIGHT) && (x <= X_MAX))
    {
        x += MOVE_SPEED;
        collideMap(&x, &y, 0, (MOVE_SPEED*-1));
        sprites[0].attrib1 = (sprites[0].attrib1 & 0xFE00) | (int)x;
        sprites[0].attrib1 = (sprites[0].attrib1 & (0xEFFF));
        if (steps >= MOVE_STEP)
        {
            if((sprites[0].attrib2 & 12) == 12)
            {
                sprites[0].attrib2 = ((sprites[0].attrib2 & 0xFC00) | 8);
            }
            else
            {
                sprites[0].attrib2 = ((sprites[0].attrib2 & 0xFC00) | 12);
            }
            steps = 0;
        }
    }
    else if(!(BUTTONS & BUTTON_UP) && (y >= Y_MIN))
    {
        y -= MOVE_SPEED;
        collideMap(&x, &y, MOVE_SPEED, 0);
        sprites[0].attrib0 = (sprites[0].attrib0 & 0xFF00) | (int)y;
        sprites[0].attrib2 = (sprites[0].attrib2 & 0xFC00) | 4;
        if (steps >= MOVE_STEP)
        {
            if((sprites[0].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[0].attrib1 = (sprites[0].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[0].attrib1 |= HORI_FLIP;
            }
            steps = 0;
        }
    }
    else if(!(BUTTONS & BUTTON_DOWN) && (y <= Y_MAX))
    {
        y += MOVE_SPEED;
        collideMap(&x, &y, (MOVE_SPEED*-1), 0);
        sprites[0].attrib0 = (sprites[0].attrib0 & 0xFF00) | (int)y;
        sprites[0].attrib2 = (sprites[0].attrib2 & 0xFC00) | 0;
        if (steps >= MOVE_STEP)
        {
            if((sprites[0].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[0].attrib1 = (sprites[0].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[0].attrib1 |= HORI_FLIP;
            }
            steps = 0;
        }
    }
}

void checkScreenChange()
{

        if (x > 224 && current_screen == 1)
        {
            x = 5;
            UpdateMap(2);
        }
        if (y > 150 && current_screen == 1 && ((x < 155) || (x > 210)))
        {
            y = 0;
            UpdateMap(4);
        }
        if (x > 224 && current_screen == 2)
        {
            x = 5;
            UpdateMap(3);
        }
        if (x < 0 && current_screen == 2)
        {
            x = 224;
            UpdateMap(1);
        }
        if (y > 150 && current_screen == 2)
        {
            y = 5;
            UpdateMap(5);
        }
        if (x < 0 && current_screen == 3)
        {
            x = 224;
            UpdateMap(2);
        }
        if (y > 150 && current_screen == 3 && ((x > 70) || (x < 10)))
        {
            y = 5;
            UpdateMap(6);
        }
        if (y < 0 && current_screen == 4)
        {
            y = 145;
            UpdateMap(1);
        }
        if (y > 150 && current_screen == 4 && x < 155)
        {
            y = 5;
            UpdateMap(7);
        }
        if (x > 224 && current_screen == 4)
        {
            x = 5;
            UpdateMap(5);
        }
        if (x > 224 && current_screen == 5)
        {
            x = 5;
            UpdateMap(6);
        }
        if (x < 0 && current_screen == 5)
        {
            x = 224;
            UpdateMap(4);
        }
        if (y < 0 && current_screen == 5)
        {
            y = 145;
            UpdateMap(2);
        }
        if (y < 0 && current_screen == 6)
        {
            y = 145;
            UpdateMap(3);
        }
        if (y > 150 && current_screen == 6 && (x > 70))
        {
            y = 0;
            UpdateMap(9);
        }
        if (x < 0 && current_screen == 6)
        {
            x = 224;
            UpdateMap(5);
        }
        if (y < 0 && current_screen == 7)
        {
            y = 145;
            UpdateMap(4);
        }
        if (y > 150 && current_screen == 7)
        {
            y = 5;
            UpdateMap(10);
        }
        if (x > 224 && current_screen == 7)
        {
            x = 5;
            UpdateMap(8);
        }
        if (x > 224 && current_screen == 8)
        {
            x = 5;
            UpdateMap(9);
        }
        if (x < 0 && current_screen == 8)
        {
            x = 224;
            UpdateMap(7);
        }
        if (y > 150 && current_screen == 8)
        {
            y = 5;
            UpdateMap(11);
        }
        if (y < 0 && current_screen == 9)
        {
            y = 145;
            UpdateMap(6);
        }
        if (y > 150 && current_screen == 9)
        {
            y = 5;
            UpdateMap(12);
        }
        if (x < 0 && current_screen == 9)
        {
            x = 224;
            UpdateMap(8);
        }
        if (y < 0 && current_screen == 10)
        {
            y = 145;
            UpdateMap(7);
        }
        if (x > 224 && current_screen == 10)
        {
            x = 5;
            UpdateMap(11);
        }
        if (x > 224 && current_screen == 11)
        {
            x = 5;
            UpdateMap(12);
        }
        if (x < 0 && current_screen == 11)
        {
            x = 224;
            UpdateMap(10);
        }
        if (y < 0 && current_screen == 11)
        {
            y = 145;
            UpdateMap(8);
        }
        if (y < 0 && current_screen == 12)
        {
            y = 145;
            UpdateMap(9);
        }
        if (x < 0 && current_screen == 12)
        {
            x = 224;
            UpdateMap(11);
        }
        
        // added by Brien
        if (y > 150 && current_screen == 13)
        {
            y = 5;
            UpdateMap(17);
        }
        if (y > 150 && current_screen == 14)
        {
            y = 5;
            UpdateMap(18);
        }
        if (x > 224 && current_screen == 15)
        {
            x = 5;
            UpdateMap(16);
        }
        if (x < 0 && current_screen == 16)
        {
            x = 224;
            UpdateMap(15);
        }
        if (y > 150 && current_screen == 16)
        {
            y = 5;
            UpdateMap(20);
        }
        if (y > 150 && current_screen == 17)
        {
            y = 5;
            UpdateMap(21);
        }
        if (x > 224 && current_screen == 17)
        {
            x = 5;
            UpdateMap(18);
        }
        if (y < 0 && current_screen == 17)
        {
            y = 150;
            UpdateMap(13);
        }
        if (x < 0 && current_screen == 18)
        {
            x = 224;
            UpdateMap(17);
        }
        if (y < 0 && current_screen == 18)
        {
            y = 150;
            UpdateMap(14);
        }
        if (x > 224 && current_screen == 19)
        {
            x = 5;
            UpdateMap(20);
        }
        if (y > 150 && current_screen == 20)
        {
            y = 5;
            UpdateMap(24);
        }
        if (y < 0 && current_screen == 20)
        {
            y = 150;
            UpdateMap(16);
        }
        if (x < 0 && current_screen == 20)
        {
            x = 224;
            UpdateMap(19);
        }
        if (y > 150 && current_screen == 21)
        {
            y = 5;
            UpdateMap(25);
        }
        if (x > 224 && current_screen == 21)
        {
            x = 5;
            UpdateMap(22);
        }
        if (y < 0 && current_screen == 21)
        {
            y = 150;
            UpdateMap(17);
        }
        if (x < 0 && current_screen == 22)
        {
            x = 224;
            UpdateMap(21);
        }
        if (x > 224 && current_screen == 22)
        {
            x = 5;
            UpdateMap(23);
        }
        if (x < 0 && current_screen == 23)
        {
            x = 224;
            UpdateMap(22);
        }
        if (y < 0 && current_screen == 24)
        {
            y = 150;
            UpdateMap(20);
        }
        if (y > 150 && current_screen == 24)
        {
            y = 5;
            UpdateMap(28);
        }
        if (y < 0 && current_screen == 25)
        {
            y = 150;
            UpdateMap(21);
        }
        if (x > 224 && current_screen == 25)
        {
            x = 5;
            UpdateMap(26);
        }
        if (x < 0 && current_screen == 26)
        {
            x = 224;
            UpdateMap(25);
        }
        if (x > 224 && current_screen == 26)
        {
            x = 5;
            UpdateMap(27);
        }
        if (x < 0 && current_screen == 27)
        {
            x = 224;
            UpdateMap(26);
        }
        if (x > 224 && current_screen == 27)
        {
            x = 5;
            UpdateMap(28);
        }
        if (x < 0 && current_screen == 28)
        {
            x = 224;
            UpdateMap(27);
        }
        if (y < 0 && current_screen == 28)
        {
            y = 150;
            UpdateMap(24);
        }
}


void animateKey()
{
    sprites[1].attrib2 = (sprites[1].attrib2 & 0xFC00) | key.frame | PALETTE(1);
    if(key.anim >= KEY_WAIT)
    {
        key.frame += 4 * key.sign;
        key.anim = 0;
        if((key.frame == 36) | (key.frame == 16)){key.sign *= -1;}
    }
    key.anim += 1;
}


void drawSprites()
{
    for(n = 0; n < 50; n++)
    {
        if(knights[n].screen == current_screen)
        {
            sprites[2 + n].attrib0 = COLOR_16 | (int)(knights[n].y);
            sprites[2 + n].attrib1 = SIZE_16 | (int)(knights[n].x);
            sprites[2 + n].attrib2 = (sprites[2 + n].attrib2 & 0xFC00) | knights[n].index;
        }else
        {
            sprites[2 + n].attrib0 = COLOR_16 | 160;
            sprites[2 + n].attrib1 = SIZE_16 | 240;
            sprites[2 + n].attrib2 = (sprites[2 + n].attrib2 & 0xFC00) | knights[n].index;
        }
    }

    for(n = 0; n < 50; n++)
    {
        if (villagers[n].screen == current_screen)
        {
            sprites[52 + n].attrib0 = COLOR_16 | (int)(villagers[n].y);
            sprites[52 + n].attrib1 = SIZE_16 | (int)(villagers[n].x);
            sprites[52 + n].attrib2 = (sprites[52 + n].attrib2 & 0xFC00) | villagers[n].index;
        }else
        {
            sprites[52 + n].attrib0 = COLOR_16 | 160;
            sprites[52 + n].attrib1 = SIZE_16 | 240;
            sprites[52 + n].attrib2 = (sprites[2 + n].attrib2 & 0xFC00) | villagers[n].index;
        }
    }

    if (key.screen == current_screen)
    {
        sprites[1].attrib0 = COLOR_16 | (int)(key.y);
        sprites[1].attrib1 = SIZE_16 | (int)(key.x);
        animateKey();
    }else
    {
        sprites[1].attrib0 = COLOR_16 | 160;
        sprites[1].attrib1 = SIZE_16 | 240;
        animateKey();
    }
    if (king_screen == current_screen)
    {
        if(r == 1){r = 0;}else{r = 1;}
        sprites[102].attrib0 = COLOR_16 | 45;
        sprites[102].attrib1 = SIZE_32 | 88;
        sprites[102].attrib2 = 80 | PALETTE(r);
        
    }else
    {
        sprites[102].attrib0 = COLOR_16 | 160;
        sprites[102].attrib1 = SIZE_32 | 140;
        sprites[102].attrib2 = 80;
    }
}

void determineVillagerMovement(float* x_vil, float* y_vil, int index)
{
    if(((int)(*y_vil) >= (int)y ) && (*y_vil <= Y_MAX) && ((int)(*x_vil) <= (int)x) && (*x_vil >= X_MIN))
    {
        *y_vil += VIL_MOVE;
        *x_vil -= VIL_MOVE;
        collideMap(x_vil, y_vil, (VIL_MOVE*-1), VIL_MOVE);
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & 0xFE00) | (int)(*x_vil);
        sprites[52 + index].attrib0 = (sprites[52 + index].attrib0 & 0xFF00) | (int)(*y_vil);
        sprites[52 + index].attrib2 = (sprites[52 + index].attrib2 & 0xFC00) | VIL_FRONT;
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[52 + index].attrib1 |= HORI_FLIP;
            }
            villagers[index].steps = 0;
        }
    }
    else if(((int)(*y_vil) >= (int)y ) && (*y_vil <= Y_MAX) && ((int)(*x_vil) > (int)x) && (*x_vil <= X_MAX))
    {
        *y_vil += VIL_MOVE;
        *x_vil += VIL_MOVE;
        collideMap(x_vil, y_vil, (VIL_MOVE*-1), (VIL_MOVE*-1));
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & 0xFE00) | (int)(*x_vil);
        sprites[52 + index].attrib0 = (sprites[52 + index].attrib0 & 0xFF00) | (int)(*y_vil);
        sprites[52 + index].attrib2 = (sprites[52 + index].attrib2 & 0xFC00) | VIL_FRONT;
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[52 + index].attrib1 |= HORI_FLIP;
            }
            villagers[index].steps = 0;
        }
    }
    else if(((int)(*y_vil) < (int)y) && (*y_vil >= Y_MIN) && ((int)(*x_vil) <= (int)x) && (*x_vil >= X_MIN))
    {
        *y_vil -= VIL_MOVE;
        *x_vil -= VIL_MOVE;
        collideMap(x_vil, y_vil, VIL_MOVE, VIL_MOVE);
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & 0xFE00) | (int)(*x_vil);
        sprites[52 + index].attrib0 = (sprites[52 + index].attrib0 & 0xFF00) | (int)(*y_vil);
        sprites[52 + index].attrib2 = (sprites[52 + index].attrib2 & 0xFC00) | VIL_BACK;
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[52 + index].attrib1 |= HORI_FLIP;
            }
            villagers[index].steps = 0;
        }
    }
    else if(((int)(*y_vil) < (int)y) && (*y_vil >= Y_MIN) && ((int)(*x_vil) > (int)x) && (*x_vil <= X_MAX))
    {
        *y_vil -= VIL_MOVE;
        *x_vil += VIL_MOVE;
        collideMap(x_vil, y_vil, VIL_MOVE, (VIL_MOVE*-1));
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & 0xFE00) | (int)(*x_vil);
        sprites[52 + index].attrib0 = (sprites[52 + index].attrib0 & 0xFF00) | (int)(*y_vil);
        sprites[52 + index].attrib2 = (sprites[52 + index].attrib2 & 0xFC00) | VIL_BACK;
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[52 + index].attrib1 |= HORI_FLIP;
            }
            villagers[index].steps = 0;
        }
    }
    else if(((int)(*x_vil) <= (int)x) && (*x_vil >= X_MIN))
    {
        *x_vil -= VIL_MOVE;
        collideMap(x_vil, y_vil, 0, VIL_MOVE);
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & 0xFE00) | (int)(*x_vil);
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & (0xEFFF));
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib2 & VIL_LEFT1) == VIL_LEFT1)
            {
                sprites[52 + index].attrib2 = ((sprites[52 + index].attrib2 & 0xFC00) | VIL_LEFT2);
            }
            else
            {
                sprites[52 + index].attrib2 = ((sprites[52 + index].attrib2 & 0xFC00) | VIL_LEFT1);
            }
            villagers[index].steps = 0;
        }
    }
    else if(((int)(*x_vil) > (int)x) && (*x_vil <= X_MAX))
    {
        *x_vil += VIL_MOVE;
        collideMap(x_vil, y_vil, 0, (VIL_MOVE*-1));
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & 0xFE00) | (int)(*x_vil);
        sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 | HORI_FLIP);
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib2 & VIL_LEFT1) == VIL_LEFT1)
            {
                sprites[52 + index].attrib2 = ((sprites[52 + index].attrib2 & 0xFC00) | VIL_LEFT2);
            }
            else
            {
                sprites[52 + index].attrib2 = ((sprites[52 + index].attrib2 & 0xFC00) | VIL_LEFT1);
            }
            villagers[index].steps = 0;
        }
    }
    else if(((int)(*y_vil) < (int)y) && (*y_vil >= Y_MIN))
    {
        *y_vil -= VIL_MOVE;
        collideMap(x_vil, y_vil, VIL_MOVE, 0);
        sprites[52 + index].attrib0 = (sprites[52 + index].attrib0 & 0xFF00) | (int)(*y_vil);
        sprites[52 + index].attrib2 = (sprites[52 + index].attrib2 & 0xFC00) | VIL_BACK;
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[52 + index].attrib1 |= HORI_FLIP;
            }
            villagers[index].steps = 0;
        }
    }
    else if(((int)(*y_vil) >= (int)y ) && (*y_vil <= Y_MAX))
    {
        *y_vil += VIL_MOVE;
        collideMap(x_vil, y_vil, (VIL_MOVE*-1), 0);
        sprites[52 + index].attrib0 = (sprites[52 + index].attrib0 & 0xFF00) | (int)(*y_vil);
        sprites[52 + index].attrib2 = (sprites[52 + index].attrib2 & 0xFC00) | VIL_FRONT;
        if (villagers[index].steps >= MOVE_STEP)
        {
            if((sprites[52 + index].attrib1 & (HORI_FLIP)) == HORI_FLIP)
            {
                sprites[52 + index].attrib1 = (sprites[52 + index].attrib1 & (0xEFFF));
            }
            else
            {
                sprites[52 + index].attrib1 |= HORI_FLIP;
            }
            villagers[index].steps = 0;
        }
    }
    villagers[index].steps += 8;
}

void determineKnightMovement(float* x_kni, float* y_kni, int index)
{
    if(((int)(*y_kni) >= (int)y ) && (*y_kni <= Y_MAX) && ((int)(*x_kni) <= (int)x) && (*x_kni >= X_MIN))
    {
        *y_kni -= KNI_MOVE;
        *x_kni += KNI_MOVE;
        collideMap(x_kni, y_kni, KNI_MOVE, (KNI_MOVE*-1));
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & 0xFE00) | (int)(*x_kni);
        sprites[2 + index].attrib0 = (sprites[2 + index].attrib0 & 0xFF00) | (int)(*y_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & (0xEFFF));
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_BACK1) == KNI_BACK1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_BACK2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_BACK1);
            }
            knights[index].steps = 0;
        }
    }
    else if(((int)(*y_kni) >= (int)y ) && (*y_kni <= Y_MAX) && ((int)(*x_kni) > (int)x) && (*x_kni <= X_MAX))
    {
        *y_kni -= KNI_MOVE;
        *x_kni -= KNI_MOVE;
        collideMap(x_kni, y_kni, (KNI_MOVE), (KNI_MOVE));
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & 0xFE00) | (int)(*x_kni);
        sprites[2 + index].attrib0 = (sprites[2 + index].attrib0 & 0xFF00) | (int)(*y_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & (0xEFFF));
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_BACK1) == KNI_BACK1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_BACK2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_BACK1);
            }
            knights[index].steps = 0;
        }
    }
    else if(((int)(*y_kni) < (int)y) && (*y_kni >= Y_MIN) && ((int)(*x_kni) <= (int)x) && (*x_kni >= X_MIN))
    {
        *y_kni += KNI_MOVE;
        *x_kni += KNI_MOVE;
        collideMap(x_kni, y_kni, (KNI_MOVE*-1), (KNI_MOVE*-1));
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & 0xFE00) | (int)(*x_kni);
        sprites[2 + index].attrib0 = (sprites[2 + index].attrib0 & 0xFF00) | (int)(*y_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & (0xEFFF));
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_FRONT1) == KNI_FRONT1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_FRONT2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_FRONT1);
            }
            knights[index].steps = 0;
        }
    }
    else if(((int)(*y_kni) < (int)y) && (*y_kni >= Y_MIN) && ((int)(*x_kni) > (int)x) && (*x_kni <= X_MAX))
    {
        *y_kni += KNI_MOVE;
        *x_kni -= KNI_MOVE;
        collideMap(x_kni, y_kni, (KNI_MOVE*-1), KNI_MOVE);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & 0xFE00) | (int)(*x_kni);
        sprites[2 + index].attrib0 = (sprites[2 + index].attrib0 & 0xFF00) | (int)(*y_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & (0xEFFF));
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_FRONT1) == KNI_FRONT1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_FRONT2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_FRONT1);
            }
            knights[index].steps = 0;
        }
    }
    else if(((int)(*x_kni) <= (int)x) && (*x_kni >= X_MIN))
    {
        *x_kni += KNI_MOVE;
        collideMap(x_kni, y_kni, 0, (KNI_MOVE*-1));
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & 0xFE00) | (int)(*x_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & (0xEFFF));
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_LEFT1) == KNI_LEFT1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_LEFT2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_LEFT1);
            }
            knights[index].steps = 0;
        }
    }
    else if(((int)(*x_kni) > (int)x) && (*x_kni <= X_MAX))
    {
        *x_kni -= KNI_MOVE;
        collideMap(x_kni, y_kni, 0, (KNI_MOVE));
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & 0xFE00) | (int)(*x_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 | HORI_FLIP);
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_LEFT1) == KNI_LEFT1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_LEFT2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_LEFT1);
            }
            knights[index].steps = 0;
        }
    }
    else if(((int)(*y_kni) < (int)y) && (*y_kni >= Y_MIN))
    {
        *y_kni += KNI_MOVE;
        collideMap(x_kni, y_kni, (KNI_MOVE*-1), 0);
        sprites[2 + index].attrib0 = (sprites[2 + index].attrib0 & 0xFF00) | (int)(*y_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & (0xEFFF));
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_FRONT1) == KNI_FRONT1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_FRONT2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_FRONT1);
            }
            knights[index].steps = 0;
        }
    }
    else if(((int)(*y_kni) >= (int)y ) && (*y_kni <= Y_MAX))
    {
        *y_kni -= KNI_MOVE;
        collideMap(x_kni, y_kni, (KNI_MOVE), 0);
        sprites[2 + index].attrib0 = (sprites[2 + index].attrib0 & 0xFF00) | (int)(*y_kni);
        sprites[2 + index].attrib1 = (sprites[2 + index].attrib1 & (0xEFFF));
        if (knights[index].steps >= MOVE_STEP)
        {
            if((sprites[2 + index].attrib2 & KNI_BACK1) == KNI_BACK1)
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_BACK2);
            }
            else
            {
                sprites[2 + index].attrib2 = ((sprites[2 + index].attrib2 & 0xFC00) | KNI_BACK1);
            }
            knights[index].steps = 0;
        }
    }
    knights[index].steps += 20;
}

void clearSprites()
{
    for(n = 0; n < 50; n++)
    {
        if (villagers[n].screen == current_screen)
        {
            villagers[n].x = 240;
            villagers[n].y = 160;
        }
        if (knights[n].screen == current_screen)
        {
            knights[n].x = 240;
            knights[n].y = 160;
        }
    }
}

void startGame()
{
    x = 150, y = 100;
    int index;
    for(index = 0; index < 128; index++)
    {
        sprites[index].attrib0 = 160;
        sprites[index].attrib1 = 240;
        sprites[index].attrib2 = 0;
    }
    
    key.x = 95;
    key.y = 135;
    key.frame = 16;
    key.anim = 1;
    key.screen = 0;
    key.sign = 1;

    current_map = 0;

    //set up background 0 & copy the tile data into tile memory
    UpdateMap(1);

    sprites[0].attrib0 = ((int)y | COLOR_16);
    sprites[0].attrib1 = ((int)x | SIZE_16);
    sprites[0].attrib2 = (PRIORITY(0) | PALETTE(1));

    for(n = 0; n < 50; n++)
    {
        knights[n].y = 64 + 16;
        knights[n].x = 104 + (int)(n/2);
        knights[n].index = 48;
        knights[n].steps = 0;
        knights[n].screen = 1 + (int)(n/2);
        sprites[2 + n].attrib0 |= COLOR_16;
        sprites[2 + n].attrib1 |= SIZE_16;
        sprites[2 + n].attrib2 = (sprites[1].attrib2 & 0xFC00) | knights[n].index | PALETTE(0);
    }

    for(n = 0; n < 50; n++)
    {
        villagers[n].y = 64;
        villagers[n].x = 104 + (int)(n/2);
        villagers[n].index = 68;
        villagers[n].steps = 0;
        villagers[n].screen = 1 + (int)(n/2);
        sprites[52 + n].attrib0 |= COLOR_16;
        sprites[52 + n].attrib1 |= SIZE_16;
        sprites[52 + n].attrib2 = (sprites[1].attrib2 & 0xFC00) | villagers[n].index | PALETTE(0);
    }

    sprites[1].attrib0 |= COLOR_16;
    sprites[1].attrib1 |= SIZE_16;
    sprites[1].attrib2 = (PRIORITY(0) | PALETTE(1));
    sprites[1].attrib2 = (sprites[1].attrib2 & 0xFC00) | key.frame;
    
    sprites[102].attrib0 |= COLOR_16;
    sprites[102].attrib1 |= SIZE_32;
    sprites[102].attrib2 = 80;
    UpdateSpriteMemory();
}
void init()
{
    //set screen global origin
   	REG_BG0VOFS = 8;
	REG_BG0HOFS = 8;
	//set video mode 0 with background 0
	SetMode(0 | BG0_ENABLE | OBJ_ENABLE | OBJ_MAP_1D);

	//copy the tile maps into background 0
	DMAFastCopy((void*)first_Map, (void*)ScreenBaseBlock(1), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)top_middle_Map, (void*)ScreenBaseBlock(2), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)second_Map, (void*)ScreenBaseBlock(3), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)up_mid_1_Map, (void*)ScreenBaseBlock(4), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)up_mid_2_Map, (void*)ScreenBaseBlock(5), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)up_mid_3_Map, (void*)ScreenBaseBlock(6), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)down_mid_1_Map, (void*)ScreenBaseBlock(7), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)down_mid_2_Map, (void*)ScreenBaseBlock(8), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)down_mid_3_Map, (void*)ScreenBaseBlock(9), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)third_Map, (void*)ScreenBaseBlock(10), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)bottom_middle_Map, (void*)ScreenBaseBlock(11), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)fourth_Map, (void*)ScreenBaseBlock(12), 1024/2, DMA_32NOW);
	
	// added by Brien
	DMAFastCopy((void*)castle1a_Map, (void*)ScreenBaseBlock(13), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1b_Map, (void*)ScreenBaseBlock(14), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1c_Map, (void*)ScreenBaseBlock(15), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1d_Map, (void*)ScreenBaseBlock(16), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1e_Map, (void*)ScreenBaseBlock(17), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1f_Map, (void*)ScreenBaseBlock(18), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1g_Map, (void*)ScreenBaseBlock(19), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1h_Map, (void*)ScreenBaseBlock(20), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1i_Map, (void*)ScreenBaseBlock(21), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1j_Map, (void*)ScreenBaseBlock(22), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1k_Map, (void*)ScreenBaseBlock(23), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1l_Map, (void*)ScreenBaseBlock(24), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1m_Map, (void*)ScreenBaseBlock(25), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1n_Map, (void*)ScreenBaseBlock(26), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1o_Map, (void*)ScreenBaseBlock(27), 1024/2, DMA_32NOW);
	DMAFastCopy((void*)castle1p_Map, (void*)ScreenBaseBlock(28), 1024/2, DMA_32NOW);
	
	

    //copy the sprite tiles into data memory
    DMAFastCopy((void*)wolfforwardTiles, &tile_mem[4][0], 32, DMA_32NOW);
    DMAFastCopy((void*)wolfbackwardsTiles, &tile_mem[4][4], 32, DMA_32NOW);
    DMAFastCopy((void*)wolfsideways1Tiles, &tile_mem[4][8], 32, DMA_32NOW);
    DMAFastCopy((void*)wolfsideways2Tiles, &tile_mem[4][12], 32, DMA_32NOW);

    DMAFastCopy((void*)key0Tiles, &tile_mem[4][16], 32, DMA_32NOW);
    DMAFastCopy((void*)key1Tiles, &tile_mem[4][20], 32, DMA_32NOW);
    DMAFastCopy((void*)key2Tiles, &tile_mem[4][24], 32, DMA_32NOW);
    DMAFastCopy((void*)key3Tiles, &tile_mem[4][28], 32, DMA_32NOW);
    DMAFastCopy((void*)key4Tiles, &tile_mem[4][32], 32, DMA_32NOW);
    DMAFastCopy((void*)key5Tiles, &tile_mem[4][36], 32, DMA_32NOW);

    DMAFastCopy((void*)knight_back_leftTiles, &tile_mem[4][40], 32, DMA_32NOW);
    DMAFastCopy((void*)knight_back_rightTiles, &tile_mem[4][44], 32, DMA_32NOW);
    DMAFastCopy((void*)knight_front_leftTiles, &tile_mem[4][48], 32, DMA_32NOW);
    DMAFastCopy((void*)knight_front_rightTiles, &tile_mem[4][52], 32, DMA_32NOW);
    DMAFastCopy((void*)knight_left_leftTiles, &tile_mem[4][56], 32, DMA_32NOW);
    DMAFastCopy((void*)knight_left_rightTiles, &tile_mem[4][60], 32, DMA_32NOW);

    DMAFastCopy((void*)villager_back_leftTiles, &tile_mem[4][64], 32, DMA_32NOW);
    DMAFastCopy((void*)villager_front_leftTiles, &tile_mem[4][68], 32, DMA_32NOW);
    DMAFastCopy((void*)villager_left_leftTiles, &tile_mem[4][72], 32, DMA_32NOW);
    DMAFastCopy((void*)villager_left_rightTiles, &tile_mem[4][76], 32, DMA_32NOW);

    DMAFastCopy((void*)king_frontTiles, &tile_mem[4][80], 256/2, DMA_32NOW);

    //copy the sprite palette into palette memory
    DMAFastCopy((void*)wolfforwardPal, &SpritePal[16], 8, DMA_32NOW);
    DMAFastCopy((void*)knight_back_leftPal, &SpritePal[0], 8, DMA_32NOW);

    //Hide All Sprites
    int index;
    for(index = 0; index < 128; index++)
    {
        sprites[index].attrib0 = 160;
        sprites[index].attrib1 = 240;
    }
    UpdateSpriteMemory();
}
//Charlie's Functions
//Brien's Functions
